package com.jugendmedia.ld25;

import java.util.HashMap;
import java.util.Map;

import org.newdawn.slick.Image;
import org.newdawn.slick.SlickException;

public class Animation {
	private Image[] frames;
	private int speed;
	private int noOfFrames;
	private static Map<String, Animation> animations;
	private Animation(String[] frames, int animspeed){
		speed = animspeed;
		
		this.frames = new Image[frames.length];
		noOfFrames = frames.length;
		for(int i=0;i<frames.length;i++){
			try {
				this.frames[i]=new Image(frames[i]);
				this.frames[i].setFilter(Image.FILTER_NEAREST);
			} catch (SlickException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		
	}
	public static void init(){
		if(animations!=null){
			return;
		}
		 animations = new HashMap<String, Animation>();
		 animations.put("GRUMPY", new Animation("grumpy1.png:grumpy2.png".split(":"),500));
		 animations.put("MUSHBOY", new Animation("mushboy1.png:mushboy2.png:mushboy3.png".split(":"),400));
		 animations.put("COOPER", new Animation("cooper1.png:cooper2.png".split(":"),400));
		 animations.put("BLUEBOY", new Animation("blueboy1.png:blueboy2.png:blueboy3.png".split(":"),400));
		 animations.put("SCHMARIO", new Animation("schmario1.png:schmario2.png:schmario3.png:schmario2.png".split(":"),200));
	}
	public static Animation getAnim(String str){
		return animations.get(str);
	}
	public float getAnimSpeed(){
		return speed;
	}
	public Image[] getFrames(){
		return frames;
	}
}
