package com.jugendmedia.ld25;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.SlickException;

public class Castle implements Waypoint, UIWindow{
	private static final int TIMEPERSLOT = 5000;
	
	private Slot[] slots;
	private int type;
	private static Image[] types;
	private static Image black;
	private int x,y;
	private int noOfSlots;
	private long timer;
	private int winX = 10;
	private int winY = 160;
	private ShoppingList shoplist;
	public ShoppingList getShoplist() {
		return shoplist;
	}
	private List<Hero> heroes = new ArrayList<Hero>();
	
	private List<Hero> removeList = new ArrayList<Hero>();
	
	List<Waypoint> waypointlist;
	
	public Castle(int noOfSlots, int x, int y, int type, List<Waypoint> waypointlist){
		this.type = type;
		this.x = x;
		this.y = y;
		this.noOfSlots = noOfSlots;
		this.timer = 0;
		this.waypointlist = waypointlist;
		
		this.shoplist= new ShoppingList(getX()+32,getY()-22);
		
		winX = x*40+noOfSlots*8;
		winY = y*40;
		if(winX<10)winX = 10;
		if(winX+noOfSlots*16>304) winX = 310-noOfSlots*16;
		slots = new Slot[noOfSlots];
		for(int i=0;i<slots.length;i++){
			slots[i]=new Slot(this);
		}
		if(types == null){
			types = new Image[2];
			try {
				black = new Image("prog_black.png");
				types[0]=new Image("castle1.png");
				types[1]=new Image("castle2.png");
				
				black.setFilter(Image.FILTER_NEAREST);
				types[0].setFilter(Image.FILTER_NEAREST);
				types[1].setFilter(Image.FILTER_NEAREST);
			} catch (SlickException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	public void draw(Graphics g){
		com.jugendmedia.ld25.Scaler.draw(g, types[type], x*40-8, y*40-21);
		for(int i=0;i<noOfSlots*3+2;i++){
			com.jugendmedia.ld25.Scaler.draw(g,black,x*40+18-(noOfSlots*2+4)+i*4,y*40 +32);
		}
		for(int i=0;i<noOfSlots;i++){
			if(!slots[i].isEmpty()&&!slots[i].isDefeated()){
				com.jugendmedia.ld25.Scaler.draw(g,slots[i].getProgImage(),x*40+18-(noOfSlots*2+4)+8+(i)*4*3,y*40 +32);
			}
			
		}
		for(Hero h:heroes){
			com.jugendmedia.ld25.Scaler.draw(g,h.getProgImage(),x*40+18-(noOfSlots*2+4)+h.getProgress(),y*40 +32);
		}
	}
	public void update(int dt){
		timer += dt;
		removeList.clear();
		
		Iterator<Hero> iter = heroes.iterator();
		
		while(iter.hasNext()){
			Hero h = iter.next();
			long timespent = timer-h.getEntryTime();
			double travelled_percent = ((double)timespent/((double)TIMEPERSLOT*(noOfSlots+1)));
			//System.out.println("travelled:"+travelled_percent);
			h.setProgress((long)(travelled_percent*(noOfSlots*4*3+8))-2);
			if((timespent-dt)/TIMEPERSLOT < (timespent/TIMEPERSLOT)){
				long encounter = (timespent-dt)/TIMEPERSLOT;
				System.out.println("encounter"+ (timespent-dt)/TIMEPERSLOT);
				System.out.println("travelled:"+travelled_percent);
				if(encounter==noOfSlots){
					//removeList.add(h);
					iter.remove();
					int myIndex = waypointlist.indexOf(this);
					if(myIndex!=-1 && (myIndex+1)!=waypointlist.size()){
						Waypoint nextStop = waypointlist.get(myIndex+1);
						Mover m = new Mover(h.getAnimName(),nextStop,h);
						m.start(getX(), getY(), nextStop.getX(), nextStop.getY());
					}else if(myIndex!=-1 && (myIndex+1)==waypointlist.size()){
						//Ran through the level
						
						if(h instanceof Schmario){
							if(Schmario.spawncount==1){
								new PauseScreen(GfxDepo.defeatOne);
								WorldMap.getInstance().setDone();
								
							}else{
								
								if(WorldMap.getInstance().damage(10)){
									new PauseScreen(GfxDepo.utterDefeat);
									WorldMap.getInstance().setExit(true);
								}else{
									new PauseScreen(GfxDepo.victory);
									WorldMap.getInstance().setExit(true);
								}
								
								WorldMap.getInstance().setDone();
							}
						}else{
							if(WorldMap.getInstance().damage(h.getDamage())){
								new PauseScreen(GfxDepo.utterDefeat);
								WorldMap.getInstance().setExit(true);
							}
							
						}
						
					}
				}else{
					Slot s = slots[(int)encounter];
					if(!s.isEmpty()&&!s.isDefeated()){
						int result = h.resolveEncounter(s.getMinion());
						switch(result){
						case Hero.AVOIDED:
							break;
						case Hero.AVOID_FAIL:
						case Hero.FOUGHT_FAIL:
							h.damageHero(s.getMinion().getDamage());
							if(h.getHealth()==0){
								//removeList.add(h);
								WorldMap.getInstance().addMoney(h.getValue());
								iter.remove();
							}
							break;
						case Hero.FOUGHT:
							s.defeat();
							break;
												
							
						}
					}
					
				}
			}
		}
	/*	for(Hero rh:removeList){
			heroes.remove(rh);
		}*/
		
	}
	@Override
	public void ImThere(Object obj) {
		if(obj instanceof Hero){
			Hero h = (Hero)obj;
			heroes.add(h);
			h.setEntryTime(timer);
		}
		
	}
	public Slot[] getSlots(){
		return slots;
	}
	@Override
	public int getX() {
		// TODO Auto-generated method stub
		return x*40+20;
	}
	@Override
	public int getY() {
		// TODO Auto-generated method stub
		return y*40+20;
	}
	@Override
	public void onClicked(int x, int y) {
		if(y>= winY && y<(winY+16)){
			if(x> (winX + slots.length*16) && x < (winX + slots.length*16+16)){
				UI.getInstance().pop();
			}else{
				for(int i=0;i<slots.length;i++){
					if(x>=(winX+16*i) && x<(winX+16*i+16)){
						if(slots[i].isEmpty()){
							UI.getInstance().push(shoplist);
							shoplist.setCurrentSlot(slots[i]);
						}
					}
				}
			}
		}
		
	}
	@Override
	public void onMouseMoved(int x1, int y1, int x2, int y2) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void winDraw(Graphics g) {
		
		int i=0;
		for(Slot s:slots){
			if(s.isEmpty()){
				com.jugendmedia.ld25.Scaler.draw(g, GfxDepo.portraitBlack, winX+i*16,winY);
			}else{
				com.jugendmedia.ld25.Scaler.draw(g, s.getMinion().getPortrait(), winX+i*16,winY);
				if(s.isDefeated()){
					com.jugendmedia.ld25.Scaler.draw(g, GfxDepo.crossedOut, winX+i*16+1,winY+1);
				}
			}
			i++;
		}
		com.jugendmedia.ld25.Scaler.draw(g, GfxDepo.portraitExit, winX+i*16,winY);
		
		
	}
	
}
