package com.jugendmedia.ld25;

import org.newdawn.slick.AppGameContainer;
import org.newdawn.slick.BasicGame;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.SlickException;

public class Game extends BasicGame {

	private WorldMap map;
	private Mover mushy;
	private Hero hero;
	
	public Game() {
		super("My Days with the Princess");
	}

	@Override
	public void render(GameContainer gc, Graphics g) throws SlickException {
		map.drawBackground(g);
		

		
		Mover.drawAll(g);
		
		for(Waypoint p:WorldMap.getTheRoute()){
			if(p instanceof Castle){
				((Castle)p).draw(g);
			}
		}
		
		UI.getInstance().drawAll(g);
		map.drawStats(g);
		
		
		
		
	}

	@Override
	public void init(GameContainer gc) throws SlickException {
		gc.setShowFPS(false);
		// TODO Auto-generated method stub
		gc.getInput().addMouseListener(UI.getInstance());
		GfxDepo.init();
		Animation.init();

		map = WorldMap.getInstance();
		new PauseScreen(GfxDepo.splasher);

	}

	@Override
	public void update(GameContainer arg0, int dt) throws SlickException {
		// TODO Auto-generated method stub
		//grumpy.update(dt);
		//mushy.update(dt);
		if(!WorldMap.getInstance().isPaused()){
			if(WorldMap.getInstance().isDone()){
				if(WorldMap.getInstance().isExit()){
					Schmario.spawncount=0;
					WorldMap.getInstance().reset();
					WorldMap.getInstance().loadLevel(Schmario.spawncount);
					new PauseScreen(GfxDepo.splasher);
				}else{
					WorldMap.getInstance().loadLevel(Schmario.spawncount);
				}
				
			}
		
			map.updateAll(dt);
			Mover.updateAll(dt);

		}

	}
    public static void main(String[] args) 
			throws SlickException
    {
         AppGameContainer app = 
			new AppGameContainer(new Game());
 
         app.setDisplayMode(1280, 960, false);
         app.setVSync(true);
         app.start();
    }

}
