package com.jugendmedia.ld25;

import org.newdawn.slick.Image;

public abstract class Hero extends MrsEntity{
	int health = -1;
	private long entryTime;
	private long progress;
	
	public static final int AVOIDED=1;
	public static final int AVOID_FAIL=2;
	public static final int FOUGHT=3;
	public static final int FOUGHT_FAIL=4;

	
	public long getProgress() {
		return progress;
	}

	public void setProgress(long progress) {
		this.progress = progress;
	}

	public long getEntryTime() {
		return entryTime;
	}

	public void setEntryTime(long entryTime) {
		this.entryTime = entryTime;
	}
	public abstract int getFight();
		
	
	public abstract int getAvoid();
	
	
	public abstract int getInitHealth();
	
	public abstract Image getProgImage();
		
	
	
	public int getHealth(){
		if(health==-1){
			health = getInitHealth();
		}
		return health;
	}
	public int damageHero(int damage){
		health -= damage;
		if(health<0){
			health=0;
		}
		return health;
	}
	protected int resolveByAvoid(Minion min){
		boolean victory = SL.win(getAvoid(),min.getBlock());
		if(victory == true){
			return AVOIDED;
		}else{
			return AVOID_FAIL;
		}
	}
		
	protected int resolveByFight(Minion min){
		boolean victory = SL.win(getFight(),min.getFight());
		if(victory == true){
			return FOUGHT;
		}else{
			return FOUGHT_FAIL;
		}
	}
	public abstract int resolveEncounter(Minion min);
		
	
	public int getDamage(){
		return 1;
	}
	public int getValue(){
		return 5;
	}
	
	
}
