package com.jugendmedia.ld25;

import org.newdawn.slick.Image;
import org.newdawn.slick.SlickException;

public class Minion {
	public static final int GRUMPY = 0;
	public static final int COOPER = 1;
	public static final int ROCKY = 2;
	
	private static Image progImages[];
	
	private Image myPortrait;
	//private static Image slotImages[];
	
	private int fight;
	private int block;
	private int type;
	private int damage;
	private String animName;
	public Minion(int type){
		if(progImages==null){
			progImages = new Image[3];
			try {
				progImages[0] = new Image("prog_grumpy.png");
				progImages[0].setFilter(Image.FILTER_NEAREST);
				progImages[1] = new Image("prog_cooper.png");
				progImages[1].setFilter(Image.FILTER_NEAREST);
				progImages[2] = new Image("prog_rocky.png");
				progImages[2].setFilter(Image.FILTER_NEAREST);


			} catch (SlickException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		this.type = type;
		switch(type){
		case GRUMPY:
			animName = "GRUMPY";
			fight = 7;
			block = 3;
			myPortrait = GfxDepo.portraitGrumpy;
			break;
		case COOPER:
			animName = "COOPER";
			fight = 7;
			block = 6;
			myPortrait = GfxDepo.portraitCooper;
			break;
		case ROCKY:
			animName = "COOPER";
			fight = 500;
			block = 6;
			myPortrait = GfxDepo.portraitRocky;
			break;			
		}
		
	}
	public int getType(){
		return type;
	}
	public int getFight(){
		return fight;
	}
	
	public int getBlock(){
		return block;
	}
	public int getDamage(){
		return damage;
	}
	public Image getProgImage(){
		return progImages[type];
	}
	public Image getPortrait(){
		return myPortrait;
	}
}
