package com.jugendmedia.ld25;

import java.util.ArrayList;
import java.util.List;

import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;

public class Mover {//animator really really....
	private static List<Mover> movers = new ArrayList<Mover>();
	
	private int startX, startY, endX, endY;
	private float speed=10;//pxls/s
	private int animSpeed=500; //ms between frames
	private int noOfFrames;
	private int currentX, currentY;
	//private float distance;
	private float transportTime;
	private boolean started;
	private long timeElapsed;
	private int currentFrame = 0;
	private Image[] frames;
	private ImThereListener imThere;
	private Object movee;
	private static List<Mover> addList = new ArrayList<Mover>();
	public Mover(String animName, ImThereListener imThere, Object movee){
		Animation anim = Animation.getAnim(animName);
		this.imThere = imThere;
		this.frames = anim.getFrames();
		this.movee = movee;
		noOfFrames = anim.getFrames().length;
	}
	public void start(int x1,int y1,int x2,int y2){
		startX = x1;
		startY = y1;
		endX = x2;
		endY = y2;
		started = true;
		timeElapsed =0;
		addList.add(this);
		
		
		int hypoX = Math.abs(endX-startX);
		int hypoY = Math.abs(endY-startY);
		float distance = (float)Math.sqrt(hypoX*hypoX + hypoY*hypoY);
		System.out.println(distance);
		transportTime = distance/speed*1000f;
	}
	private void update(int ds){
		if(started){
			timeElapsed+=ds;
			currentFrame = (int)timeElapsed/animSpeed%noOfFrames;
			currentX = (int)(startX+(timeElapsed/transportTime)*(endX-startX));
			currentY = (int)(startY+(timeElapsed/transportTime)*(endY-startY));
			
		
			if(timeElapsed>=transportTime){
				started=false;
				if(imThere!=null){
					imThere.ImThere(movee);
				}
			}
		}
	}
	private void draw(Graphics g){
		if(started){
			com.jugendmedia.ld25.Scaler.draw(g, frames[currentFrame], currentX-8, currentY-23);
		}
	}
	
	
	public static void updateAll(int dt){
		movers.addAll(addList);
		addList.clear();
		for(Mover m:movers){
			m.update(dt);
		}

	}

	public static void drawAll(Graphics g){
		for(Mover m:movers){
			m.draw(g);
		}
	}

}
