package com.jugendmedia.ld25;

import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;

public class ShoppingList implements UIWindow {

	private MenuItem[] menu = new MenuItem[3];
	
	
	private int winX, winY;
	private Slot current;
	public ShoppingList(int x, int y){
		winX = x;
		winY = y;
	
		if(winY < 10) winY =10;
		if(winX > 262) winX = 262;
		
		if(winY+menu.length*16>230){
			winY = 230-menu.length*16;
		}
		
		MenuItem item = new MenuItem(50);
		item.setPortrait(GfxDepo.portraitGrumpy);
		menu[Minion.GRUMPY] = item;
		
		item = new MenuItem(75);
		item.setPortrait(GfxDepo.portraitCooper);
		menu[Minion.COOPER] = item;

		item = new MenuItem(200);
		item.setPortrait(GfxDepo.portraitRocky);
		menu[Minion.ROCKY] = item;
		
	}
	
	public void setCurrentSlot(Slot s){
		current = s;
	}
	
	
	public MenuItem get(int type){
		return menu[type];
	}
	
	class MenuItem{
		private int price;
		private boolean enabled=true;
		private Image portrait;
		
		public Image getPortrait() {
			return portrait;
		}

		public void setPortrait(Image portrait) {
			this.portrait = portrait;
		}

		MenuItem(int price){
			this.price = price;
		}
		
		public int getPrice() {
			return price;
		}
		public void setPrice(int price) {
			this.price = price;
		}
		public boolean isEnabled() {
			return enabled;
		}
		public void setEnabled(boolean enabled) {
			this.enabled = enabled;
		}
	}
	
	@Override
	public void onClicked(int x, int y) {
		
		if(x>(winX+16) && x <(winX+48)){
			for(int i=0;i<menu.length;i++){
				if(y>=(winY+16*i) && y<(winY+16*i+16)){
					
					if(menu[i].isEnabled() && WorldMap.getInstance().buy(menu[i].getPrice())){
						current.setMinion(new Minion(i));
						UI.getInstance().pop();					
					}
					

					
				}
				
			}
			
		}
		if(x>=winX && x<(winX+16) &&
				 y>=winY+menu.length*16 && y<(winY+menu.length*16+16)){
			UI.getInstance().pop();
		}
		


	}

	@Override
	public void onMouseMoved(int x1, int y1, int x2, int y2) {
		// TODO Auto-generated method stub

	}

	@Override
	public void winDraw(Graphics g) {
		for(int i=0;i<menu.length;i++){
			com.jugendmedia.ld25.Scaler.draw(g, menu[i].getPortrait(), winX, winY+16*i);
			if(WorldMap.getInstance().canBuy(menu[i].getPrice()) && menu[i].isEnabled()){
				com.jugendmedia.ld25.Scaler.draw(g, GfxDepo.buy, winX+16, winY+16*i);	
			}else{
				com.jugendmedia.ld25.Scaler.draw(g, GfxDepo.buyGrey, winX+16, winY+16*i);
			}
			
			g.drawString(""+menu[i].getPrice(), (30+winX)*Scaler.SCALE, (winY+17*i+8)*Scaler.SCALE);
		}
		com.jugendmedia.ld25.Scaler.draw(g, GfxDepo.portraitExit, winX, winY+16*menu.length);

	}
	
	

}
