package com.jugendmedia.ld25;

import static com.jugendmedia.ld25.Scaler.draw;

import java.util.ArrayList;
import java.util.List;

import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.SlickException;


public class WorldMap implements UIWindow{
	
	private static WorldMap instance;
	
	public static Image cooperOverlay;
	public static Image cooperBeach;
	public static Image grumpyTown;
	public static final int WIDTH = 8;
	public static final int HEIGHT = 6;
	public static final int TILEWIDTH = 40;
	public static List<Waypoint> theRoute = new ArrayList<Waypoint>();


	private static final int[][] levels= new int[2][]; 
	private static final int[][] castles= new int[2][]; 
	private static final int[] level1 = {   0, 0, 0, 0, 0, 0, 0, 2,
											0, 0, 0, 0, 0, 0, 0, 2,
											0, 0, 0, 5, 1, 1, 1, 3,
											0, 0, 0, 2, 0, 0, 0, 0,
											1, 1, 1, 3, 0, 0,11, 8,
											8, 8, 8,10, 0, 0, 7, 0};
	private static final int[] level2 = {   0, 0, 0, 0, 0, 0, 0, 0,
											1, 1, 1, 4, 0, 0, 0, 0,
											8, 8, 8, 9, 8, 8, 8, 8,
											0, 0, 0, 6, 1, 1, 4, 0,
											0, 0, 0, 0, 0, 0, 2, 0,
											0, 0, 5, 1, 1, 1, 3, 0};

	private static final int[] castle1 = {    2, 1, 4, 0, //noOfSlots,  x, y, type (-1 = Forwarder)
										      0, 3, 4,-1,
										      4, 3, 2, 0,
										      3, 6, 2, 1};
	
	private static final int[] castle2 = {    7, 3, 1, 0, //noOfSlots,  x, y, type (-1 = Forwarder)
										      0, 3, 3,-1,
										      4, 5, 3, 0,
										      0, 6, 3,-1,
										      0, 6, 5,-1,
										      8, 4, 5, 0,
										      4, 2, 5, 1};

	
	private static final int[] grumpytown =  { 1,2,
											   5,4};
	private static final int[] cooperbeach = { 2,5,
		                                       1,2};
	private static final int[] startcoords = { -1,4,
											   -1,1};
	private static final int[] startcash = { 150,300};
	
	private Wave theWave;

	private int startX,startY;
	private boolean exit;
	
	static{
		levels[0] = level1;
		castles[0] = castle1;
		levels[1] = level2;
		castles[1] = castle2;

	}
	private Tile[] tileset = new Tile[WIDTH*HEIGHT];
	private int grumpyX,grumpyY,cooperX,cooperY;
	private int cash=0;
	private int life=20;

	private boolean paused;

	private boolean mapDone;
	


	private WorldMap(){
		loadLevel(0);
		UI.getInstance().push(this);
		if(cooperOverlay==null){
			try {
				cooperOverlay = new Image("coopers_beach_n_overlay.png");
				cooperOverlay.setFilter(Image.FILTER_NEAREST);
				cooperBeach = new Image("coopers_beach_n_back.png");
				cooperBeach.setFilter(Image.FILTER_NEAREST);
				grumpyTown = new Image("grumpyville.png");
				grumpyTown.setFilter(Image.FILTER_NEAREST);
			} catch (SlickException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}
		//TODO:hack
		((Castle)theRoute.get(0)).getSlots()[0].setMinion(new Minion(Minion.GRUMPY));
		

	}
	
	public static WorldMap getInstance(){
		if(instance==null){
			instance = new WorldMap();
		}
		return instance;
	}
	
	public void loadLevel(int level) {
		mapDone=false;
		int[] layout = levels[level];
		for(int i=0;i<layout.length;i++){
			tileset[i]=new Tile(layout[i]);
		}
		theRoute.clear();
		int[] castlelist = castles[level];
		for(int i=0;i<castlelist.length/4;i++){
			if(castlelist[i*4+3]==-1){
				Forwarder f = new Forwarder(castlelist[i*4+1], castlelist[i*4+2], theRoute);
				theRoute.add(f);
			}else{
				Castle castle = new Castle(castlelist[i*4], castlelist[i*4+1], castlelist[i*4+2], castlelist[i*4+3],theRoute);
				theRoute.add(castle);
				if(level==1){
					if(castlelist[i*4+2]>2){
						castle.getShoplist().get(Minion.COOPER).setEnabled(false);
						
						
					}else{
						castle.getShoplist().get(Minion.GRUMPY).setEnabled(false);
						castle.getShoplist().get(Minion.ROCKY).setPrice(400);
					}
					
				}
			}
			
		}
		grumpyX=grumpytown[level*2];
		grumpyY=grumpytown[level*2+1];
		cooperX=cooperbeach[level*2];
		cooperY=cooperbeach[level*2+1];
		startX=startcoords[level*2];
		startY=startcoords[level*2+1];
		cash+= startcash[level];
		
		theWave = new Wave(level);
		
	}
	public void drawBackground(Graphics g){
		for(int i=0;i< WIDTH*HEIGHT;i++){
			draw(g,tileset[i].getImage(),(i%WIDTH)*TILEWIDTH, i/WIDTH*TILEWIDTH);
			
		}
		draw(g,grumpyTown,grumpyX*TILEWIDTH,grumpyY*TILEWIDTH);
		draw(g,cooperBeach,cooperX*TILEWIDTH,cooperY*TILEWIDTH);
	}
	@Override
	public void onClicked(int x, int y) {
		System.out.println("xy"+x+":"+y);
		for(Waypoint p:theRoute){
			if(p instanceof Castle){
				Castle c = (Castle)p; 
				if(x > c.getX()-10 && x < (c.getX()+40+10) &&
				   y > c.getY()-10 && y < (c.getY()+40)){
					UI.getInstance().push(c);

				}
			}
		}
	}
	@Override
	public void onMouseMoved(int x1, int y1, int x2, int y2) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void winDraw(Graphics g) {

		draw(g, cooperOverlay, cooperX*40, cooperY*40);
		
	}
	public Waypoint getFirstWaypoint(){
		return theRoute.get(0);
	}
	public void updateAll(int dt) {
		for(Waypoint p:theRoute){
			if(p instanceof Castle){
				((Castle)p).update(dt);
			}
		}
		theWave.update(dt);
		
	}
	public int getGrumpyX() {
		return grumpyX;
	}
	public int getGrumpyY() {
		return grumpyY;
	}
	public int getCooperX() {
		return cooperX;
	}
	public int getCooperY() {
		return cooperY;
	}
	public void drawStats(Graphics g) {
		draw(g,GfxDepo.statBar,240,1);
		g.drawString(""+cash,260*Scaler.SCALE, 1*Scaler.SCALE);
		g.drawString(""+life,246*Scaler.SCALE, 1*Scaler.SCALE);
		
	}
	public boolean canBuy(int cost){
		if(cost>cash){
			return false;
		}else{
			return true;
		}
		
	}
	public boolean buy(int cost){
		if(cost>cash){
			return false;
		}else{
			cash-=cost;
			return true;
		}
	}
	public boolean damage(int dmg){
		life-=dmg;
		if(life<0){
			life=0;
		}
		return life<1;
	}

	public void addMoney(int value) {
		cash+=value;
		
	}
	public static List<Waypoint> getTheRoute() {
		return theRoute;
	}

	public void pause() {
		paused=true;
		
	}
	public void unpause() {
		paused=false;
		
	}
	public boolean isPaused(){
		return paused;
	}
	public int getStartX() {
		return startX;
	}

	public int getStartY() {
		return startY;
	}

	public void setDone() {
		mapDone = true;
		
	}
	public boolean isDone(){
		return mapDone;
	}

	public boolean isExit() {
		return exit;
	}

	public void setExit(boolean exit) {
		this.exit = exit;
	}

	public void reset() {
		life=20;
		cash=0;
		exit=false;
		mapDone=false;
		
	}
}
